# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.1914
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from visier_platform_sdk.models.assign_revoke_permission_by_permission_dto import AssignRevokePermissionByPermissionDTO
from typing import Optional, Set
from typing_extensions import Self

class AssignRevokePermissionByTenantDTO(BaseModel):
    """
    The permissions organized by tenant.
    """ # noqa: E501
    tenant_code: Optional[StrictStr] = Field(default=None, description="The unique identifier associated with the tenant.", alias="tenantCode")
    permissions: Optional[List[AssignRevokePermissionByPermissionDTO]] = Field(default=None, description="A list of objects representing the assigned or removed permissions.")
    status: Optional[StrictStr] = Field(default=None, description="The state of the permission assignment. Valid values are Succeed or Failed.")
    message: Optional[StrictStr] = Field(default=None, description="A detailed description of the request outcome, if available.")
    project_id: Optional[StrictStr] = Field(default=None, description="The ID of the project that the change was made in, if applicable.", alias="projectId")
    __properties: ClassVar[List[str]] = ["tenantCode", "permissions", "status", "message", "projectId"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Unknown', 'Succeed', 'Failed']):
            raise ValueError("must be one of enum values ('Unknown', 'Succeed', 'Failed')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AssignRevokePermissionByTenantDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in permissions (list)
        _items = []
        if self.permissions:
            for _item_permissions in self.permissions:
                if _item_permissions:
                    _items.append(_item_permissions.to_dict())
            _dict['permissions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AssignRevokePermissionByTenantDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tenantCode": obj.get("tenantCode"),
            "permissions": [AssignRevokePermissionByPermissionDTO.from_dict(_item) for _item in obj["permissions"]] if obj.get("permissions") is not None else None,
            "status": obj.get("status"),
            "message": obj.get("message"),
            "projectId": obj.get("projectId")
        })
        return _obj


