# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.1914
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PushDataColumnDefinitionDTO(BaseModel):
    """
    Definition of the source column.
    """ # noqa: E501
    column_name: Optional[StrictStr] = Field(default=None, description="The name of the column.", alias="columnName")
    data_type: Optional[StrictStr] = Field(default=None, description="The data type associated with the column.", alias="dataType")
    data_formats: Optional[List[StrictStr]] = Field(default=None, description="The expected format for datetime data types.", alias="dataFormats")
    is_mandatory: Optional[StrictBool] = Field(default=None, description="If true, the column value is required. If a column is mandatory, and the file is missing this column, the request will fail.", alias="isMandatory")
    allow_empty: Optional[StrictBool] = Field(default=None, description="If true, the column allows an empty value for the record.", alias="allowEmpty")
    default_value: Optional[StrictStr] = Field(default=None, description="The default value of the column.", alias="defaultValue")
    __properties: ClassVar[List[str]] = ["columnName", "dataType", "dataFormats", "isMandatory", "allowEmpty", "defaultValue"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PushDataColumnDefinitionDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PushDataColumnDefinitionDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "columnName": obj.get("columnName"),
            "dataType": obj.get("dataType"),
            "dataFormats": obj.get("dataFormats"),
            "isMandatory": obj.get("isMandatory"),
            "allowEmpty": obj.get("allowEmpty"),
            "defaultValue": obj.get("defaultValue")
        })
        return _obj


