# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.1914
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from visier_platform_sdk.models.dimension_member_reference_dto import DimensionMemberReferenceDTO
from visier_platform_sdk.models.dimension_reference_dto import DimensionReferenceDTO
from typing import Optional, Set
from typing_extensions import Self

class QueryMemberMapSelectionDTO(BaseModel):
    """
    A QueryMemberMapSelection groups data in a query by dimension members in a member map.  This allows grouping by a dimension that isn't typically valid on the analytic object being  queried by selecting a valid member map on the analytic object.  Note: This is unique to the data query API and cannot be reproduced in Visier's interface.
    """ # noqa: E501
    member_map: Optional[DimensionReferenceDTO] = Field(default=None, description="A member map and its qualifying path to query.", alias="memberMap")
    target_dimension_name: Optional[StrictStr] = Field(default=None, description="The name of the member map's dimension that you want to query. The member selection is based on this dimension.", alias="targetDimensionName")
    members: Optional[List[DimensionMemberReferenceDTO]] = Field(default=None, description="A collection of the selected dimension members from the `targetDimension`. This must contain at least one member.")
    __properties: ClassVar[List[str]] = ["memberMap", "targetDimensionName", "members"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QueryMemberMapSelectionDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of member_map
        if self.member_map:
            _dict['memberMap'] = self.member_map.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in members (list)
        _items = []
        if self.members:
            for _item_members in self.members:
                if _item_members:
                    _items.append(_item_members.to_dict())
            _dict['members'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QueryMemberMapSelectionDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "memberMap": DimensionReferenceDTO.from_dict(obj["memberMap"]) if obj.get("memberMap") is not None else None,
            "targetDimensionName": obj.get("targetDimensionName"),
            "members": [DimensionMemberReferenceDTO.from_dict(_item) for _item in obj["members"]] if obj.get("members") is not None else None
        })
        return _obj


