# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.1914
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from visier_platform_sdk.models.clone_files_into_source_parameters_dto import CloneFilesIntoSourceParametersDTO
from typing import Optional, Set
from typing_extensions import Self

class SourcesAPIOperationRequestDTO(BaseModel):
    """
    SourcesAPIOperationRequestDTO
    """ # noqa: E501
    operation: Optional[StrictStr] = Field(default=None, description="The operation to perform. Valid values:  * `exportSources`: Export all sources from the tenant. If successful, returns a ZIP file containing a compressed JSON file with the sources.  * `cloneFilesIntoSource`: Clone a source's files into a different source. If successful, returns a receiving job ID. Use the job ID to monitor the cloning results.")
    clone_files_into_source_parameters: Optional[CloneFilesIntoSourceParametersDTO] = Field(default=None, description="The parameters for the `cloneFilesIntoSource` option, such as the source to clone files from, the source to clone files into, and the date range of the files to clone.", alias="cloneFilesIntoSourceParameters")
    __properties: ClassVar[List[str]] = ["operation", "cloneFilesIntoSourceParameters"]

    @field_validator('operation')
    def operation_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['unknownSourcesAPIOperation', 'exportSources', 'cloneFilesIntoSource']):
            raise ValueError("must be one of enum values ('unknownSourcesAPIOperation', 'exportSources', 'cloneFilesIntoSource')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SourcesAPIOperationRequestDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of clone_files_into_source_parameters
        if self.clone_files_into_source_parameters:
            _dict['cloneFilesIntoSourceParameters'] = self.clone_files_into_source_parameters.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SourcesAPIOperationRequestDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "operation": obj.get("operation"),
            "cloneFilesIntoSourceParameters": CloneFilesIntoSourceParametersDTO.from_dict(obj["cloneFilesIntoSourceParameters"]) if obj.get("cloneFilesIntoSourceParameters") is not None else None
        })
        return _obj


